Codeforces Round #361 (Div. 2) D. Friends and Subsequences (二分+RMQ)

来源:互联网 发布:扫描二维码抽奖软件 编辑:程序博客网 时间:2024/05/16 00:41

Mike and !Mike are old childhood rivals, they are opposite in everything they do, except programming. Today they have a problem they cannot solve on their own, but together (with you) — who knows?

Every one of them has an integer sequences a andb of length n. Being given a query of the form of pair of integers(l, r), Mike can instantly tell the value of while !Mike can instantly tell the value of.

Now suppose a robot (you!) asks them all possible different queries of pairs of integers(l, r) (1 ≤ l ≤ r ≤ n) (so he will make exactlyn(n + 1) / 2 queries) and counts how many times their answers coincide, thus for how many pairs is satisfied.

How many occasions will the robot count?

Input

The first line contains only integer n (1 ≤ n ≤ 200 000).

The second line contains n integer numbersa1, a2, ..., an ( - 109 ≤ ai ≤ 109) — the sequence a.

The third line contains n integer numbersb1, b2, ..., bn ( - 109 ≤ bi ≤ 109) — the sequence b.

Output

Print the only integer number — the number of occasions the robot will count, thus for how many pairs is satisfied.

Examples
Input
61 2 3 2 1 46 7 1 2 3 2
Output
2
Input
33 3 31 1 1
Output
0
Note

The occasions in the first sample case are:

1.l = 4,r = 4 sincemax{2} = min{2}.

2.l = 4,r = 5 sincemax{2, 1} = min{2, 3}.

There are no occasions in the second sample case since Mike will answer 3 to any query pair, but !Mike will always answer 1.


题意:给你两个数列A,B,问你有多少组区间[l,r]满足其在A中的最大值等于B中的最小值。


分析:枚举区间的起始位置,通过简单分析可以得出,以l为起点的所求区间的r必定是连续的一段,且这段长度内的max = min,事先RMQ处理一下,随后二分出左右端点记入答案。

#include <cstdio>#include <queue>    #include <vector>    #include <cstdio>    #include <utility>    #include <cstring>    #include <iostream>    #include <algorithm>    #define INF 0x3f3f3f3fusing namespace std;long long ans;int n,a[200007],b[200007];int Fma[200007][20];int Fmi[200007][20];int qumax(int l,int r){int leng = log2(r-l+1);return max(Fma[l][leng],Fma[r-(1 << leng)+1][leng]);}int qumin(int l,int r){int leng = log2(r-l+1);return min(Fmi[l][leng],Fmi[r-(1 << leng)+1][leng]);}int main(){scanf("%d",&n);for(int i = 1;i <= n;i++) scanf("%d",&a[i]);for(int i = 1;i <= n;i++) scanf("%d",&b[i]);for(int i = 1;i <= n;i++){Fma[i][0] = a[i];Fmi[i][0] = b[i];}for(int i = 1;(1 << i) <= n;i++) for(int j = 1;j + (1 << i) -1 <= n;j++) {Fma[j][i] = max(Fma[j][i-1],Fma[j+(1 << (i-1))][i-1]);Fmi[j][i] = min(Fmi[j][i-1],Fmi[j+(1 << (i-1))][i-1]); }for(int i = 1;i <= n;i++){int s = i;int t = n;while(s != t){    int mid = (s+t)/2;if(qumax(i,mid) >= qumin(i,mid)) t = mid;else s = mid+1;}if(qumax(i,s) != qumin(i,s)) continue;int l = s;s = i,t = n;while(s != t){    int mid = (s+t)/2+1;if(qumax(i,mid) <= qumin(i,mid)) s = mid;else t = mid-1;}int r = s;ans += r-l+1ll;} cout<<ans<<endl;}



0 0
原创粉丝点击